//***************************************************
// KOKUIN.pas
// 󕶎̍}NCf[^쐬܂
// ̃XNvgSSTN̍ix[XɂĂ܂
// The joint production of SSTN and Alpha. 2002/04/25
//***************************************************

program KOKUIN;

const
{--------------̕Cӂɐݒ肵Ă------------------------------------------------}
  C_String   = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789-*#/'; // gpł镶ꗗ
  C_Width    = 2.0 / 3.0;                                  // ̕(ɑ΂䗦)
  C_Space    = 0.2;                                        // m̊Ԋu(ɑ΂䗦)
  
  C_Opening1 = 'N666' + #13#10 + 'M06' + #13#10 + 'T000' + #13#10 + 'N6661';
  C_Opening2 = 'G90G00G54X0.0Y0.0M08' + #13#10 + '(T000 KOKUIN-10 H000)';
  C_Opening3 = 'G43Z50.0H000' + #13#10 + 'S1000' + #13#10 + 'M03';
  
  C_Initial  = '50.0';          // CjV_
  C_Rpoint   = '5.0';           // q_
  C_Zvalue   = 'G01Z-0.1F100';  // H[Ɛ؂荞ݑ
  C_Fvalue   = 'F100';          // wx
  
  C_Ending1  = #13#10 + 'M05' + #13#10 + 'G90G00Z50.0M09' + #13#10 + 'M01';
{--------------̕Cӂɐݒ肵Ă------------------------------------------------}

var
  strMozi  : string;       // }
  dobHeight: Double;       // 
  dobWidth : Double;       // 
  intLength: Integer;      // 󕶎̕
  chrMozi  : Char;         // PÂp
  dobBufX  : Double;       // ŏ̂wWێp
  dobSpace : Double;       // m̊Ԋu
  X, Y, X1, Y1, R: Double; // }p̍W
  i: Integer; // JE^p

// ͂ꂽ̃`FbNp***********************************************************************
function STR_CHECK(S: String): Boolean;
var
  myCount: Integer; // ͂ꂽ̕ioCgj
  myStr  : String;  // ͂ꂽPoCgÂ`FbN邽߂Ɏgp
  myI    : Integer; // JE^p
begin
  // ߂lfalseɈUݒ
  Result := false;
  // ioCgj擾
  myCount := Length(S);
  // PoCgÂmF
  for myI := 1 to myCount do
  begin
    myStr := Copy(S, myI, 1);
    // gpł镶ꗗiC_StringjɂȂ֐I
    if (Pos(myStr, C_String) = 0) then Exit;
  end;
  // S`FbNtrueɂ
  Result := true;
end;


// mb`֐EEE]ȃ[Ȃ*************************************************************
function NC_FORMAT(form: String; v: Double): String;
var
  myBuf: String;  // mb`ێp
  myStr: string;  // PÂ`FbNp
  myI  : integer; // JE^p
begin
  // 𕶎ɕϊ
  myBuf := FloatToStrF(form, v);
  // ̖PoCgÂmF
  for myI := Length(myBuf) DownTo 1 do
  begin
    myStr := copy(myBuf, myI, 1);
    // [Ȃ폜
    if myStr = '0' then
      Delete(myBuf, myI, 1)
    else
      // hbgȂ[forI
      if myStr = '.' then
      begin
        myBuf := myBuf + '0';
        break;
      end
      else
      // ȊO牽forI
        break;
  end;
  Result := myBuf;
end;


// CvO********************************************************************************
begin

  InitEditor('NCvO'); // GfB^̏
  InitDlg; // _CAȌ
  
  AddLabel(10,  20,  50, 20, '󕶎');
  AddLabel(15,  40, 320, 20, 'gp\ȕꗗ');
  AddLabel(15,  55, 320, 20, C_String);
  AddLabel(10,  90,  50, 20, '');
  AddLabel(15, 110, 320, 20, 'F' + FloatToStrF('%f', C_Width) + '  ԊuF' + FloatToStrF('%f', C_Space) + '  ɂȂ܂');
  
  AddEdit(1, 70, 17, 250, 20, 'A');
  AddEdit(2, 70, 87,  50, 20, '6.0');
  
  if ShowDlg(350,180,'󕶎p[^') <> true then Exit;
  
  // }āASĂgpł镶ꗗiC_Stringjɂ邩`FbN
  strMozi := GetDlgText(1);
  if (STR_CHECK(strMozi) <> true) then
  begin
    OkMsgBox('͕ɂ͎gps̕܂܂Ă܂B𒆎~܂B');
    Exit;
  end;
  
  // ̐ݒAłȂƂ͋IA[ȉُ͈I
  dobHeight := StrToFloat(GetDlgText(2));
  if (dobHeight <= 0.0) then
  begin
    OkMsgBox('͂ꂽُ͈łB𒆎~܂');
    Exit;
  end;
  
  // ̔zuʒu̐ݒ
  Message('̔zuʒúij');
  if (GetPos(X, Y) <> true) then Exit;
  Message('XNvgs');
  
  // 󕶎̐擾
  intLength := Length(strMozi);
  
  // wWꎞێ
  dobBufX := X;
  
  // ̐ݒÂ͍Q^R
  dobWidth := dobHeight * C_Width;
  
  // m̊Ԋuݒ
  dobSpace := dobHeight * C_Space;
  
  // vO`̍쐬
  Writeln(C_Opening1);
  Writeln(C_Opening2);
  Writeln(C_Opening3);
  
  Writeln('(.' + strMozi + ')');
  
  // PÂ`揈NCvO쐬
  for i := 0 to (intLength - 1) do
  begin
    // ̂wWlݒ
    X := dobBufX + (i * dobWidth) + (i * dobSpace);
    
    // PÂԂɎ擾
    chrMozi := Copy(strMozi, i + 1, 1);
    
    // ʂ̏
    case chrMozi of
      
      'A': //`}NCo
      begin
        Line(X, Y - dobHeight, X + (dobWidth / 2.0), Y);
        Line(X + (dobWidth / 2.0), Y, X + dobWidth, Y - dobHeight);
        Line(X + (dobWidth / 6.0), Y - (dobHeight * 2.0 / 3.0), X + (dobWidth * 5.0 / 6.0), Y - (dobHeight * 2.0 / 3.0));
        Writeln('(.A)');
        Writeln(NC_FORMAT('X%.3F', X) + NC_FORMAT('Y%.3F', Y));
        Writeln('G91Y-' + NC_FORMAT('%.3F', dobHeight));
        Writeln('G90Z' + C_Rpoint);
        Writeln(C_Zvalue);
        Writeln('G91X' + NC_FORMAT('%.3F', dobWidth / 2.0) + NC_FORMAT('Y%.3F', dobHeight) + C_Fvalue);
        Writeln(NC_FORMAT('X%.3F', dobWidth / 2.0) + NC_FORMAT('Y-%.3F', dobHeight));
        Writeln(NC_FORMAT('X-%.3F', dobWidth / 6.0) + NC_FORMAT('Y%.3F', dobHeight * 1.0 / 3.0));
        Writeln(NC_FORMAT('X-%.3F',dobWidth * 2.0 / 3.0));
        Writeln('G90G00Z' + C_Initial);
      end; 
      
      'B': //a}NCo
      begin
        X1 := X + dobWidth - (dobHeight / 4.0);
        Line(X, Y, X, Y - dobHeight);
        Line(X, Y - dobHeight, X1, Y - dobHeight);
        Line(X, Y - (dobHeight / 2.0), X1, Y - (dobHeight / 2.0));
        Line(X, Y, X1, Y);
        Arc(X1, Y - (dobHeight / 4.0), dobHeight / 4.0, -90.0, 90.0);
        Arc(X1, Y - dobHeight + (dobHeight / 4.0), dobHeight / 4.0, -90.0, 90.0);
        X1 := dobWidth - (dobHeight / 4.0);
        Writeln('(.B)');
        Writeln(NC_FORMAT('X%.3F', X) + NC_FORMAT('Y%.3F', Y));
        Writeln('G90Z' + C_Rpoint);
        Writeln(C_Zvalue);
        Writeln('G91' + NC_FORMAT('Y-%.3F', dobHeight) + C_Fvalue);
        Writeln(NC_FORMAT('X%.3F', X1));
        Writeln('G03' + NC_FORMAT('Y%.3F', dobHeight/2) + NC_FORMAT('R%.3F',dobHeight / 4.0));
        Writeln('G01' + NC_FORMAT('X-%.3F', X1));
        Writeln(NC_FORMAT('X%.3F', X1));
        Writeln('G03' + NC_FORMAT('Y%.3F', dobHeight/2) + NC_FORMAT('R%.3F', dobHeight / 4.0));
        Writeln('G01' + NC_FORMAT('X-%.3F', X1));
        Writeln('G90G00Z' + C_Initial);
      end;
      
      'C': //b}NCo
      begin
        X1 := dobHeight / 4.0;
        Arc(X + dobWidth - X1, Y-X1, X1, 0.0, 90.0);
        Line(X + dobWidth - X1, Y, X + X1, Y);
        Arc(X + X1, Y - X1, X1, 90.0, 180.0);
        Line(X, Y - X1, X, Y - dobHeight + X1);
        Arc(X + X1, Y - dobHeight + X1, X1, 180.0, 270.0);
        Line(X + X1, Y - dobHeight, X + dobWidth - X1, Y - dobHeight);
        Arc(X + dobWidth - X1, Y - dobHeight + X1, X1, -90.0, 0.0);
        Writeln('(.C)');
        Writeln(NC_FORMAT('X%.3F', X) + NC_FORMAT('Y%.3F', Y));
        Writeln('G91' + NC_FORMAT('X%.3F', dobWidth) + NC_FORMAT('Y-%.3F', X1));
        Writeln('G90Z' + C_Rpoint);
        Writeln(C_Zvalue);
        Writeln('G91G03' + NC_FORMAT('X-%.3F', X1) + NC_FORMAT('Y%.3F', X1) + NC_FORMAT('R%.3F', X1) + C_Fvalue);
        Writeln('G01' + NC_FORMAT('X-%.3F', dobWidth / 4.0));
        Writeln('G03' + NC_FORMAT('X-%.3F', X1) + NC_FORMAT('Y-%.3F', X1) + NC_FORMAT('R%.3F', X1));
        Writeln(NC_FORMAT('G01Y-%.3F', dobHeight / 2.0));
        Writeln('G03' + NC_FORMAT('X%.3F', X1) + NC_FORMAT('Y-%.3F', X1) + NC_FORMAT('R%.3F', X1));
        Writeln('G01' + NC_FORMAT('X%.3F', dobWidth / 4.0));
        Writeln('G03' + NC_FORMAT('X%.3F', X1) + NC_FORMAT('Y%.3F', X1) + NC_FORMAT('R%.3F', X1));
        Writeln('G90G00Z' + C_Initial);
      end;
      
      'D': //c}NCo
      begin
        X1 := dobWidth / 2.0;
        Line(X, Y, X, Y - dobHeight);
        Line(X, Y - dobHeight, X + X1, Y - dobHeight);
        Arc(X + X1, Y - dobHeight + X1, X1, -90,0);
        Line(X + dobWidth, Y - dobHeight + X1, X + dobWidth, Y - X1);
        Arc(X + X1, Y - X1, X1, 0.0, 90.0);
        Line(X + X1, Y, X, Y);
        Writeln('(.D)');
        Writeln(NC_FORMAT('X%.3F', X) + NC_FORMAT('Y%.3F', Y));
        Writeln('G90Z' + C_Rpoint);
        Writeln(C_Zvalue);
        Writeln('G91' + NC_FORMAT('Y-%.3F', dobHeight) + C_Fvalue);
        Writeln(NC_FORMAT('X%.3F', X1));
        Writeln(NC_FORMAT('G03X%.3F', X1) + NC_FORMAT('Y%.3F', X1) + NC_FORMAT('R%.3F', X1));
        Writeln(NC_FORMAT('G01Y%.3F', X1));
        Writeln(NC_FORMAT('G03X-%.3F', X1) + NC_FORMAT('Y%.3F', X1) + NC_FORMAT('R%.3F', X1));
        Writeln(NC_FORMAT('G01X-%.3F', X1));
        Writeln('G90G00Z' + C_Initial);
      end;
      
      'E': //d}NCo
      begin
        X1 := dobHeight / 2.0;
        Line(X, Y, X + dobWidth, Y);
        Line(X, Y, X, Y - dobHeight);
        Line(X, Y - X1, X + X1, Y - X1);
        Line(X, Y - dobHeight, X + dobWidth, Y - dobHeight);
        Writeln('(.E)');
        Writeln(NC_FORMAT('X%.3F', X) + NC_FORMAT('Y%.3F', Y));
        Writeln(NC_FORMAT('G91X%.3F', dobWidth));
        Writeln('G90Z' + C_Rpoint);
        Writeln(C_Zvalue);
        Writeln(NC_FORMAT('G91X-%.3F', dobWidth) + C_Fvalue);
        Writeln(NC_FORMAT('Y-%.3F', X1));
        Writeln(NC_FORMAT('X%.3F', X1));
        Writeln(NC_FORMAT('X-%.3F', X1));
        Writeln(NC_FORMAT('Y-%.3F', X1));
        Writeln(NC_FORMAT('X%.3F', dobWidth));
        Writeln('G90G00Z' + C_Initial);
      end; 
      
      'F': //e}NCo
      begin
        X1 := dobHeight / 2.0;
        Line(X, Y, X + dobWidth, Y);
        Line(X, Y, X, Y - dobHeight);
        Line(X, Y - X1, X + X1, Y - X1);
        Writeln('(.F)');
        Writeln(NC_FORMAT('X%.3F', X) + NC_FORMAT('Y%.3F', Y));
        Writeln(NC_FORMAT('G91X%.3F', dobWidth));
        Writeln('G90Z' + C_Rpoint);
        Writeln(C_Zvalue);
        Writeln(NC_FORMAT('G91X-%.3F', dobWidth) + C_Fvalue);
        Writeln(NC_FORMAT('Y-%.3F', X1));
        Writeln(NC_FORMAT('X%.3F', X1));
        Writeln(NC_FORMAT('X-%.3F', X1));
        Writeln(NC_FORMAT('Y-%.3F', X1));
        Writeln('G90G00Z' + C_Initial);
      end; 
      
      'G': //f}NCo
      begin
        X1 := dobWidth / 2.0;
        Arc(X + X1, Y - X1, X1, 0.0, 180.0);
        Line(X, Y - X1, X, Y - (X1 * 2.0));
        Arc(X + X1, Y - (X1 * 2.0), X1, -180,0);
        Line(X + dobWidth, Y - (X1 * 2.0), X + dobWidth, Y - (dobHeight / 2.0));
        Line(X + dobWidth, Y - (dobHeight / 2.0), X + dobWidth - (X1 / 2.0), Y - (dobHeight / 2.0));
        Writeln('(.G)');
        Writeln(NC_FORMAT('X%.3F', X) + NC_FORMAT('Y%.3F', Y));
        Writeln(NC_FORMAT('G91X%.3F', dobWidth) + NC_FORMAT('Y-%.3F', X1));
        Writeln('G90Z' + C_Rpoint);
        Writeln(C_Zvalue);
        Writeln(NC_FORMAT('G91G03X-%.3F', dobWidth) + NC_FORMAT('R%.3F', X1) + C_Fvalue);
        Writeln(NC_FORMAT('G01Y-%.3F', X1));
        Writeln(NC_FORMAT('G03X%.3F', dobWidth) + NC_FORMAT('R%.3F', X1));
        Writeln(NC_FORMAT('G01Y%.3F', X1 / 2.0));
        Writeln(NC_FORMAT('X-%.3F', X1 / 2.0));
        Writeln('G90G00Z' + C_Initial);
      end;
      
      'H': //g}NCo
      begin
        X1 := dobHeight / 2.0;
        Line(X, Y, X, Y - dobHeight);
        Line(X, Y - X1, X + dobWidth, Y - X1);
        Line(X + dobWidth, Y, X + dobWidth, Y - dobHeight);
        Writeln('(.H)');
        Writeln(NC_FORMAT('X%.3F', X) + NC_FORMAT('Y%.3F', Y));
        Writeln('G90Z' + C_Rpoint);
        Writeln(C_Zvalue);
        Writeln('G91' + NC_FORMAT('Y-%.3F', dobHeight) + C_Fvalue);
        Writeln(NC_FORMAT('Y%.3F', X1));
        Writeln(NC_FORMAT('X%.3F', dobWidth));
        Writeln(NC_FORMAT('Y%.3F', X1));
        Writeln(NC_FORMAT('Y-%.3F', dobHeight));
        Writeln('G90G00Z' + C_Initial);
      end;
      
      'I': //h}NCo
      begin
        X1 := dobWidth / 3.0;
        Y1 := dobWidth / 2.0;
        Line(X + X1, Y, X + (X1 * 2.0), Y);
        Line(X + Y1, Y, X + Y1, Y - dobHeight);
        Line(X + X1, Y - dobHeight, X + (X1 * 2.0), Y - dobHeight);
        Y1 := X1 / 2.0;
        Writeln('(.I)');
        Writeln(NC_FORMAT('X%.3F', X) + NC_FORMAT('Y%.3F', Y));
        Writeln(NC_FORMAT('G91X%.3F', X1 * 2.0));
        Writeln('G90Z' + C_Rpoint);
        Writeln(C_Zvalue);
        Writeln(NC_FORMAT('G91X-%.3F', X1) + C_Fvalue);
        Writeln(NC_FORMAT('X%.3F', Y1));
        Writeln(NC_FORMAT('Y-%.3F', dobHeight));
        Writeln(NC_FORMAT('X-%.3F', Y1));
        Writeln(NC_FORMAT('X%.3F', X1));
        Writeln('G90G00Z' + C_Initial);
      end;
      
      'J': //i}NCo
      begin
        X1 := dobWidth / 2.0;
        Y1 := dobHeight / 6.0;
        Line(X + X1, Y, X + dobWidth, Y);
        Line(X + X1 + Y1, Y, X + X1 + Y1, Y - dobHeight + Y1);
        Arc(X + X1, Y - dobHeight + Y1, Y1, -90,0);
        Line(X + X1, Y - dobHeight, X + Y1, Y - dobHeight);
        Arc(X + Y1, Y - dobHeight + Y1, Y1, 180.0, 270.0);
        Writeln('(.J)');
        Writeln(NC_FORMAT('X%.3F', X) + NC_FORMAT('Y%.3F', Y));
        Writeln(NC_FORMAT('G91X%.3F', X1));
        Writeln('G90Z' + C_Rpoint);
        Writeln(C_Zvalue);
        Writeln(NC_FORMAT('G91X%.3F', X1) + C_Fvalue);
        Writeln(NC_FORMAT('X-%.3F', Y1));
        Writeln(NC_FORMAT('Y-%.3F', dobHeight - Y1));
        Writeln(NC_FORMAT('G02X-%.3F', Y1) + NC_FORMAT('Y-%.3F', Y1) + NC_FORMAT('R%.3F', Y1));
        Writeln(NC_FORMAT('G01X-%.3F', Y1));
        Writeln(NC_FORMAT('G02X-%.3F', Y1) + NC_FORMAT('Y%.3F', Y1) + NC_FORMAT('R%.3F', Y1));
        Writeln('G90G00Z' + C_Initial);
      end;
      
      'K': //j}NCo
      begin
        X1 := dobWidth / 3.0;
        Y1 := dobWidth / 6.0 * 5.0;
        Line(X, Y, X, Y - dobHeight);
        Line(X + dobWidth, Y, X, Y - dobWidth);
        Line(X + X1, Y + Y1 - dobHeight, X + dobWidth, Y - dobHeight);
        Writeln('(.K)');
        Writeln(NC_FORMAT('X%.3F', X) + NC_FORMAT('Y%.3F', Y));
        Writeln('G90Z' + C_Rpoint);
        Writeln(C_Zvalue);
        Writeln(NC_FORMAT('G91Y-%.3F', dobHeight) + C_Fvalue);
        Writeln(NC_FORMAT('Y%.3F', dobHeight - dobWidth));
        Writeln(NC_FORMAT('X%.3F', dobWidth) + NC_FORMAT('Y%.3F', dobWidth));
        Writeln(NC_FORMAT('X-%.3F', dobWidth - X1) + NC_FORMAT('Y-%.3F', dobWidth - X1));
        Writeln(NC_FORMAT('X%.3F', dobWidth - X1) + NC_FORMAT('Y-%.3F', Y1));
        Writeln('G90G00Z' + C_Initial);
      end;
      
      'L': //k}NCo
      begin
        Line(X, Y, X, Y - dobHeight);
        Line(X, Y - dobHeight, X + dobWidth, Y - dobHeight);
        Writeln('(.L)');
        Writeln(NC_FORMAT('X%.3F', X) + NC_FORMAT('Y%.3F', Y));
        Writeln('G90Z' + C_Rpoint);
        Writeln(C_Zvalue);
        Writeln(NC_FORMAT('G91Y-%.3F', dobHeight) + C_Fvalue);
        Writeln(NC_FORMAT('X%.3F', dobWidth));
        Writeln('G90G00Z' + C_Initial);
      end;
      
      'M': //l}NCo
      begin
        X1 := dobWidth / 2.0;
        Y1 := dobHeight / 3.0 * 2.0;
        Line(X, Y, X, Y - dobHeight);
        Line(X, Y, X + X1, Y - Y1);
        Line(X + X1, Y - Y1, X + dobWidth, Y);
        Line(X + dobWidth, Y, X + dobWidth, Y - dobHeight);
        Writeln('(.M)');
        Writeln(NC_FORMAT('X%.3F', X) + NC_FORMAT('Y%.3F', Y));
        Writeln(NC_FORMAT('G91Y-%.3F', dobHeight));
        Writeln('G90Z' + C_Rpoint);
        Writeln(C_Zvalue);
        Writeln(NC_FORMAT('G91Y%.3F', dobHeight) + C_Fvalue);
        Writeln(NC_FORMAT('X%.3F', X1) + NC_FORMAT('Y-%.3F', Y1));
        Writeln(NC_FORMAT('X%.3F', X1) + NC_FORMAT('Y%.3F', Y1));
        Writeln(NC_FORMAT('Y-%.3F', dobHeight));
        Writeln('G90G00Z' + C_Initial);
      end;
      
      'N': //m}NCo
      begin
        Line(X, Y, X, Y - dobHeight);
        Line(X, Y, X + dobWidth, Y - dobHeight);
        Line(X + dobWidth, Y, X + dobWidth, Y - dobHeight);
        Writeln('(.N)');
        Writeln(NC_FORMAT('X%.3F', X) + NC_FORMAT('Y%.3F', Y));
        Writeln(NC_FORMAT('G91Y-%.3F', dobHeight));
        Writeln('G90Z' + C_Rpoint);
        Writeln(C_Zvalue);
        Writeln(NC_FORMAT('G91Y%.3F', dobHeight) + C_Fvalue);
        Writeln(NC_FORMAT('X%.3F', dobWidth) + NC_FORMAT('Y-%.3F', dobHeight));
        Writeln(NC_FORMAT('Y%.3F', dobHeight));
        Writeln('G90G00Z' + C_Initial);
      end;
      
      'O': //n}NCo  
      begin
        X1 := dobWidth / 2.0;
        Y1 := dobHeight - dobWidth;
        Arc(X + X1, Y - X1, X1, 0.0, 180.0);
        Line(X, Y - X1, X, Y - X1 -Y1);  
        Arc(X + X1, Y - dobHeight + X1, X1, -180,0);
        Line(X + dobWidth, Y - X1 - Y1, X + dobWidth, Y-X1);
        Writeln('(.O)');
        Writeln(NC_FORMAT('X%.3F', X) + NC_FORMAT('Y%.3F', Y));
        Writeln(NC_FORMAT('G91X%.3F', dobWidth) + NC_FORMAT('Y-%.3F', X1));
        Writeln('G90Z' + C_Rpoint);
        Writeln(C_Zvalue);
        Writeln(NC_FORMAT('G91G03X-%.3F', dobWidth) + NC_FORMAT('R%.3F', X1) + C_Fvalue);
        Writeln(NC_FORMAT('G01Y-%.3F', Y1));
        Writeln(NC_FORMAT('G03X%.3F', dobWidth) + NC_FORMAT('R%.3F', X1));
        Writeln(NC_FORMAT('G01Y%.3F', Y1));
        Writeln('G90G00Z' + C_Initial);
      end;
      
      'P': //o}NCo  
      begin
        Y1 := dobHeight / 4.0;
        X1 := dobWidth - Y1;
        Line(X, Y, X, Y - dobHeight);
        Line(X, Y, X + X1, Y);  
        Arc(X + X1, Y - Y1, Y1, -90.0, 90.0);
        Line(X, Y - (Y1 * 2.0), X + X1, Y - (Y1 * 2.0));
        Writeln('(.P)');
        Writeln(NC_FORMAT('X%.3F', X) + NC_FORMAT('Y%.3F', Y));
        Writeln(NC_FORMAT('G91Y-%.3F', dobHeight));
        Writeln('G90Z' + C_Rpoint);
        Writeln(C_Zvalue);
        Writeln(NC_FORMAT('G91Y%.3F', dobHeight) + C_Fvalue);
        Writeln(NC_FORMAT('X%.3F', X1));
        Writeln(NC_FORMAT('G02Y-%.3F', Y1 * 2.0) + NC_FORMAT('R%.3F', Y1));
        Writeln(NC_FORMAT('G01X-%.3F', X1));
        Writeln('G90G00Z' + C_Initial);
      end;
      
      'Q': //p}NCo  
      begin
        X1 := dobWidth / 2.0;
        Y1 := dobHeight - dobWidth;
        Arc(X + X1, Y - X1, X1, 0.0, 180.0);
        Line(X, Y - X1, X, Y - X1 - Y1);  
        Arc(X + X1, Y - dobHeight + X1, X1, -180,0);
        Line(X + dobWidth, Y - X1 - Y1, X + dobWidth, Y - X1);
        Arc(X + X1, Y - dobHeight + dobHeight / 10.0, dobHeight / 10.0, 90.0, 270.0);
        Line(X + X1, Y - dobHeight + dobHeight / 5.0, X + dobWidth, Y - dobHeight);
        Writeln('(.Q)');
        Writeln(NC_FORMAT('X%.3F', X) + NC_FORMAT('Y%.3F', Y));
        Writeln(NC_FORMAT('G91X%.3F', X1) + NC_FORMAT('Y-%.3F', dobHeight));
        Writeln('G90Z' + C_Rpoint);
        Writeln(C_Zvalue);
        Writeln(NC_FORMAT('G91G02X-%.3F', X1) + NC_FORMAT('Y%.3F', X1) + NC_FORMAT('R%.3F', X1) + C_Fvalue);
        Writeln(NC_FORMAT('G01Y%.3F', Y1));
        Writeln(NC_FORMAT('G02X%.3F', dobWidth) + NC_FORMAT('R%.3F', X1));
        Writeln(NC_FORMAT('G01Y-%.3F', Y1));
        Writeln(NC_FORMAT('G02X-%.3F', X1) + NC_FORMAT('Y-%.3F', X1) + NC_FORMAT('R%.3F', X1));
        Writeln(NC_FORMAT('Y%.3F', dobHeight / 5.0) + NC_FORMAT('R%.3F', dobHeight / 10.0));
        Writeln(NC_FORMAT('G01X%.3F', X1) + NC_FORMAT('Y-%.3F', dobHeight / 5.0));
        Writeln('G90G00Z' + C_Initial);
      end;
      
      'R': //q}NCo  
      begin
        Y1 := dobHeight / 4.0;
        X1 := dobWidth - Y1;
        Line(X, Y, X, Y - dobHeight);
        Line(X, Y, X + X1, Y);  
        Arc(X + X1, Y - Y1, Y1, -90.0, 90.0);
        Line(X, Y - (Y1 * 2.0), X + X1, Y - (Y1 * 2.0));
        Line(X + X1, Y - (Y1 * 2.0), X + dobWidth, Y - dobHeight);
        Writeln('(.R)');
        Writeln(NC_FORMAT('X%.3F', X) + NC_FORMAT('Y%.3F', Y));
        Writeln(NC_FORMAT('G91Y-%.3F', dobHeight));
        Writeln('G90Z' + C_Rpoint);
        Writeln(C_Zvalue);
        Writeln(NC_FORMAT('G91Y%.3F', dobHeight) + C_Fvalue);
        Writeln(NC_FORMAT('X%.3F', X1));
        Writeln(NC_FORMAT('G02Y-%.3F', Y1 * 2.0) + NC_FORMAT('R%.3F', Y1));
        Writeln(NC_FORMAT('G01X-%.3F', X1));
        Writeln(NC_FORMAT('X%.3F', X1));
        Writeln(NC_FORMAT('X%.3F', Y1) + NC_FORMAT('Y-%.3F', Y1 * 2.0));
        Writeln('G90G00Z' + C_Initial);
      end;
      
      'S': //r}NCo  
      begin
        Y1 := dobHeight/4;
        X1 := dobWidth/4;
        Arc(X + dobWidth - Y1, Y - Y1, Y1, 0.0, 90.0);
        Line(X + dobWidth - Y1, Y, X + Y1, Y);
        Arc(X + Y1, Y - Y1, Y1, 90.0, 270.0);
        Line(X + Y1, Y - (Y1 * 2.0), X + dobWidth - Y1, Y - (Y1 * 2.0));
        Arc(X + dobWidth - Y1, Y - dobHeight + Y1, Y1, -90.0, 90.0);
        Line(X + dobWidth - Y1, Y - dobHeight, X + Y1, Y - dobHeight);
        Arc(X + Y1, Y - dobHeight + Y1, Y1, 180.0, 270.0);
        Writeln('(.S)');
        Writeln(NC_FORMAT('X%.3F', X) + NC_FORMAT('Y%.3F', Y));
        Writeln(NC_FORMAT('G91X%.3F', dobWidth) + NC_FORMAT('Y-%.3F', Y1));
        Writeln('G90Z' + C_Rpoint);
        Writeln(C_Zvalue);
        Writeln(NC_FORMAT('G91G03X-%.3F', Y1) + NC_FORMAT('Y%.3F', Y1) + NC_FORMAT('R%.3F', Y1) + C_Fvalue);
        Writeln(NC_FORMAT('G01X-%.3F', X1));
        Writeln(NC_FORMAT('G03Y-%.3F', Y1 * 2.0) + NC_FORMAT('R%.3F', Y1));
        Writeln(NC_FORMAT('G01X%.3F', X1));
        Writeln(NC_FORMAT('G02Y-%.3F', Y1 * 2.0) + NC_FORMAT('R%.3F', Y1));
        Writeln(NC_FORMAT('G01X-%.3F', X1));
        Writeln(NC_FORMAT('G02X-%.3F', Y1) + NC_FORMAT('Y%.3F', Y1) + NC_FORMAT('R%.3F', Y1));
        Writeln('G90G00Z' + C_Initial);
      end;
      
      'T': //s}NCo
      begin
        X1 := dobWidth / 2.0;
        Line(X + X1, Y, X + X1, Y - dobHeight);
        Line(X, Y, X + dobWidth, Y);
        Writeln('(.T)');
        Writeln(NC_FORMAT('X%.3F', X) + NC_FORMAT('Y%.3F', Y));
        Writeln('G90Z' + C_Rpoint);
        Writeln(C_Zvalue);
        Writeln(NC_FORMAT('G91X%.3F', dobWidth) + C_Fvalue);
        Writeln(NC_FORMAT('X-%.3F', X1));
        Writeln(NC_FORMAT('Y-%.3F', dobHeight));
        Writeln('G90G00Z' + C_Initial);
      end;
      
      'U': //t}NCo  
      begin
        X1 := dobWidth / 2.0;
        Y1 := dobHeight - X1;
        Line(X, Y, X, Y - Y1);  
        Arc(X + X1, Y - dobHeight + X1, X1, -180,0);
        Line(X + dobWidth, Y - Y1, X + dobWidth, Y);
        Writeln('(.U)');
        Writeln(NC_FORMAT('X%.3F', X) + NC_FORMAT('Y%.3F', Y));
        Writeln('G90Z' + C_Rpoint);
        Writeln(C_Zvalue);
        Writeln(NC_FORMAT('G91Y-%.3F', Y1) + C_Fvalue);
        Writeln(NC_FORMAT('G03X%.3F', dobWidth) + NC_FORMAT('R%.3F', X1));
        Writeln(NC_FORMAT('G01Y%.3F', Y1));
        Writeln('G90G00Z' + C_Initial);
      end;
      
      'V': //u}NCo
      begin
        X1 := dobWidth / 2.0;
        Line(X, Y, X + X1, Y - dobHeight);
        Line(X + X1, Y - dobHeight, X + dobWidth, Y);
        Writeln('(.V)');
        Writeln(NC_FORMAT('X%.3F', X) + NC_FORMAT('Y%.3F', Y));
        Writeln('G90Z' + C_Rpoint);
        Writeln(C_Zvalue);
        Writeln(NC_FORMAT('G91X%.3F', X1) + NC_FORMAT('Y-%.3F', dobHeight) + C_Fvalue);
        Writeln(NC_FORMAT('X%.3F', X1) + NC_FORMAT('Y%.3F', dobHeight));
        Writeln('G90G00Z' + C_Initial);
      end;
      
      'W': //v}NCo
      begin
        X1 := dobWidth / 4.0;
        Y1 := dobHeight - X1;
        Line(X, Y, X + X1, Y - dobHeight);
        Line(X + X1, Y - dobHeight, X + (X1 * 2.0), Y - X1);
        Line(X + (X1 * 2.0), Y - X1, X + (X1 * 3.0), Y - dobHeight);
        Line(X + (X1 * 3.0), Y - dobHeight, X + dobWidth, Y);
        Writeln('(.W)');
        Writeln(NC_FORMAT('X%.3F', X) + NC_FORMAT('Y%.3F', Y));
        Writeln('G90Z' + C_Rpoint);
        Writeln(C_Zvalue);
        Writeln(NC_FORMAT('G91X%.3F', X1) + NC_FORMAT('Y-%.3F', dobHeight) + C_Fvalue);
        Writeln(NC_FORMAT('X%.3F', X1) + NC_FORMAT('Y%.3F', Y1));
        Writeln(NC_FORMAT('X%.3F', X1) + NC_FORMAT('Y-%.3F', Y1));
        Writeln(NC_FORMAT('X%.3F', X1) + NC_FORMAT('Y%.3F', dobHeight));
        Writeln('G90G00Z' + C_Initial);
      end;
      
      'X': //w}NCo
      begin
        X1 := dobWidth / 2.0;
        Y1 := dobHeight / 2.0;
        Line(X, Y, X + dobWidth, Y - dobHeight);
        Line(X, Y - dobHeight, X + dobWidth, Y);
        Writeln('(.X)');
        Writeln(NC_FORMAT('X%.3F', X) + NC_FORMAT('Y%.3F', Y));
        Writeln('G90Z' + C_Rpoint);
        Writeln(C_Zvalue);
        Writeln(NC_FORMAT('G91X%.3F', dobWidth) + NC_FORMAT('Y-%.3F', dobHeight) + C_Fvalue);
        Writeln(NC_FORMAT('X-%.3F', X1) + NC_FORMAT('Y%.3F', Y1));
        Writeln(NC_FORMAT('X-%.3F', X1) + NC_FORMAT('Y-%.3F', Y1));
        Writeln(NC_FORMAT('X%.3F', dobWidth) + NC_FORMAT('Y%.3F', dobHeight));
        Writeln('G90G00Z' + C_Initial);
      end;
      
      'Y': //x}NCo
      begin
        X1 := dobWidth / 2.0;
        Y1 := dobHeight / 2.0;
        Line(X, Y, X + X1, Y - Y1);
        Line(X + dobWidth, Y, X + X1, Y - Y1);
        Line(X + X1, Y - Y1, X + X1, Y - dobHeight);
        Writeln('(.Y)');
        Writeln(NC_FORMAT('X%.3F', X) + NC_FORMAT('Y%.3F', Y));
        Writeln('G90Z' + C_Rpoint);
        Writeln(C_Zvalue);
        Writeln(NC_FORMAT('G91X%.3F', X1) + NC_FORMAT('Y-%.3F', Y1) + C_Fvalue);
        Writeln(NC_FORMAT('X%.3F', X1) + NC_FORMAT('Y%.3F', Y1));
        Writeln(NC_FORMAT('X-%.3F', X1) + NC_FORMAT('Y-%.3F', Y1));
        Writeln(NC_FORMAT('Y-%.3F', Y1));
        Writeln('G90G00Z' + C_Initial);
      end;
      
      'Z': //y}NCo
      begin
        Line(X, Y, X + dobWidth, Y);
        Line(X + dobWidth, Y, X, Y - dobHeight);
        Line(X, Y - dobHeight, X + dobWidth, Y - dobHeight);
        Writeln('(.Z)');
        Writeln(NC_FORMAT('X%.3F', X) + NC_FORMAT('Y%.3F', Y));
        Writeln('G90Z' + C_Rpoint);
        Writeln(C_Zvalue);
        Writeln(NC_FORMAT('G91X%.3F', dobWidth) + C_Fvalue);
        Writeln(NC_FORMAT('X-%.3F', dobWidth) + NC_FORMAT('Y-%.3F', dobHeight));
        Writeln(NC_FORMAT('X%.3F', dobWidth));
        Writeln('G90G00Z' + C_Initial);
      end;
      
      '0': //Oi[j}NCo  
      begin
        X1 := dobHeight / 4.0;
        Y1 := dobHeight / 2.0;
        Arc(X + X1, Y - X1, X1, 90.0, 180.0);
        Line(X,Y-X1,X,Y-X1-Y1);
        Arc(X + X1, Y - X1 - Y1, X1, 180.0, 270.0);
        Line(X + X1, Y - dobHeight, X + dobWidth - X1, Y - dobHeight);
        Arc(X + dobWidth - X1, Y - dobHeight + X1, X1, -90,0);
        Line(X + dobWidth, Y - dobHeight + X1, X + dobWidth, Y - X1);
        Arc(X + dobWidth - X1, Y - X1, X1, 0.0, 90.0);
        Line(X + dobWidth - X1, Y, X + X1, Y);
        Writeln('(.0)');
        Writeln(NC_FORMAT('X%.3F', X) + NC_FORMAT('Y%.3F', Y));
        Writeln(NC_FORMAT('G91X%.3F', X1));
        Writeln('G90Z' + C_Rpoint);
        Writeln(C_Zvalue);
        Writeln(NC_FORMAT('G91G03X-%.3F', X1) + NC_FORMAT('Y-%.3F', X1) + NC_FORMAT('R%.3F', X1) + C_Fvalue);
        Writeln(NC_FORMAT('G01Y-%.3F', Y1));
        Writeln(NC_FORMAT('G03X%.3F', X1) + NC_FORMAT('Y-%.3F', X1) + NC_FORMAT('R%.3F', X1));
        Writeln(NC_FORMAT('G01X%.3F', dobWidth - (X1 * 2.0)));
        Writeln(NC_FORMAT('G03X%.3F', X1) + NC_FORMAT('Y%.3F', X1) + NC_FORMAT('R%.3F', X1));
        Writeln(NC_FORMAT('G01Y%.3F', Y1));
        Writeln(NC_FORMAT('G03X-%.3F', X1) + NC_FORMAT('Y%.3F', X1) + NC_FORMAT('R%.3F', X1));
        Writeln(NC_FORMAT('G01X-%.3F', dobWidth - (X1 * 2.0)));
        Writeln('G90G00Z' + C_Initial);
      end;
      
      '1': //P}NCo
      begin
        X1 := dobHeight/6;
        Line(X + X1, Y - X1, X + (X1 * 2.0), Y);
        Line(X + (dobWidth / 2.0), Y, X + (dobWidth / 2.0), Y - dobHeight);
        Line(X + X1, Y - dobHeight, X + (X1 * 3.0), Y - dobHeight);
        Y1 := X1 / 2.0;
        Writeln('(.1)');
        Writeln(NC_FORMAT('X%.3F', X) + NC_FORMAT('Y%.3F', Y));
        Writeln(NC_FORMAT('G91X%.3F', X1) + NC_FORMAT('Y-%.3F', X1));
        Writeln('G90Z' + C_Rpoint);
        Writeln(C_Zvalue);
        Writeln(NC_FORMAT('G91X%.3F', X1) + NC_FORMAT('Y%.3F', X1) + C_Fvalue);
        Writeln(NC_FORMAT('Y-%.3F', dobHeight));
        Writeln(NC_FORMAT('X-%.3F', X1));
        Writeln(NC_FORMAT('X%.3F', X1 * 2.0));
        Writeln('G90G00Z' + C_Initial);
      end;
      
      '2': //Q}NCo  
      begin
        X1 := dobHeight / 4.0;
        Y1 := dobWidth - (X1 * 2.0);
        Arc(X + X1, Y - X1, X1, 90.0, 180.0);
        Line(X + X1, Y, X + X1 + Y1, Y);
        Arc(X + dobWidth - X1, Y - X1, X1, -90.0, 90.0);
        Line(X + X1, Y - (X1 * 2.0), X + dobWidth - X1, Y - (X1 * 2.0));
        Arc(X + X1, Y - (X1 * 3.0), X1, 90.0, 180.0);
        Line(X, Y - (X1 * 3.0), X, Y - dobHeight);
        Line(X, Y - dobHeight, X + dobWidth, Y - dobHeight);
        Writeln('(.2)');
        Writeln(NC_FORMAT('X%.3F', X) + NC_FORMAT('Y%.3F', Y));
        Writeln(NC_FORMAT('G91Y-%.3F', X1));
        Writeln('G90Z' + C_Rpoint);
        Writeln(C_Zvalue);
        Writeln(NC_FORMAT('G91G02X%.3F', X1) + NC_FORMAT('Y%.3F', X1) + NC_FORMAT('R%.3F', X1) + C_Fvalue);
        Writeln(NC_FORMAT('G01X%.3F', Y1));
        Writeln(NC_FORMAT('G02Y-%.3F', X1 * 2.0) + NC_FORMAT('R%.3F', X1));
        Writeln(NC_FORMAT('G01X-%.3F', Y1));
        Writeln(NC_FORMAT('G03X-%.3F', X1) + NC_FORMAT('Y-%.3F', X1) + NC_FORMAT('R%.3F', X1));
        Writeln(NC_FORMAT('G01Y-%.3F', X1));
        Writeln(NC_FORMAT('G01X%.3F', dobWidth));
        Writeln('G90G00Z' + C_Initial);
      end;
      
      '3': //R}NCo  
      begin
        X1 := dobHeight / 4.0;
        Y1 := dobWidth - (X1 * 2.0);
        Arc(X + X1, Y - X1, X1, 90.0, 180.0);
        Line(X + X1, Y, X + X1 + Y1, Y);
        Arc(X + dobWidth - X1, Y - X1, X1, -90.0, 90.0);
        Line(X + X1, Y - (X1 * 2.0), X + dobWidth - X1, Y - (X1 * 2.0));
        Arc(X + dobWidth - X1, Y - (X1 * 3.0), X1, -90.0, 90.0);
        Line(X + X1, Y - dobHeight, X + dobWidth - X1, Y - dobHeight);
        Arc(X + X1, Y - dobHeight + X1, X1, 180.0, 270.0);
        Writeln('(.3)');
        Writeln(NC_FORMAT('X%.3F', X) + NC_FORMAT('Y%.3F', Y));
        Writeln(NC_FORMAT('G91Y-%.3F',X1));
        Writeln('G90Z' + C_Rpoint);
        Writeln(C_Zvalue);
        Writeln(NC_FORMAT('G91G02X%.3F', X1) + NC_FORMAT('Y%.3F', X1) + NC_FORMAT('R%.3F', X1) + C_Fvalue);
        Writeln(NC_FORMAT('G01X%.3F', Y1));
        Writeln(NC_FORMAT('G02Y-%.3F', X1 * 2.0) + NC_FORMAT('R%.3F', X1));
        Writeln(NC_FORMAT('G01X-%.3F', Y1));
        Writeln(NC_FORMAT('X%.3F', Y1));
        Writeln(NC_FORMAT('G02Y-%.3F', X1 * 2.0) + NC_FORMAT('R%.3F', X1));
        Writeln(NC_FORMAT('G01X-%.3F', Y1));
        Writeln(NC_FORMAT('G02X-%.3F', X1) + NC_FORMAT('Y%.3F', X1) + NC_FORMAT('R%.3F', X1));
        Writeln('G90G00Z' + C_Initial);
      end;
      
      '4': //S}NCo
      begin
        X1 := dobHeight / 6.0;
        Line(X, Y - dobHeight + X1, X + dobWidth, Y - dobHeight + X1);
        Line(X, Y - dobHeight + X1, X + dobWidth - X1, Y);
        Line(X + dobWidth - X1, Y, X + dobWidth - X1, Y - dobHeight);
        Writeln('(.4)');
        Writeln(NC_FORMAT('X%.3F', X) + NC_FORMAT('Y%.3F', Y));
        Writeln(NC_FORMAT('G91X%.3F', dobWidth-X1) + NC_FORMAT('Y-%.3F', dobHeight));
        Writeln('G90Z' + C_Rpoint);
        Writeln(C_Zvalue);
        Writeln(NC_FORMAT('G91Y%.3F', dobHeight) + C_Fvalue);
        Writeln(NC_FORMAT('X-%.3F', dobWidth - X1) + NC_FORMAT('Y-%.3F', dobHeight-X1));
        Writeln(NC_FORMAT('X%.3F', dobWidth));
        Writeln('G90G00Z' + C_Initial);
      end;
      
      '5': //T}NCo
      begin
        X1 := dobHeight / 4.0;
        Line(X, Y, X + dobWidth, Y);
        Line(X, Y, X, Y - (dobHeight / 3.0) - (dobHeight / 8.0));
        Arc(X + (COS(30.0) * X1), Y - (dobHeight / 3.0) - X1, X1, 90.0, 150.0);
        Line(X + (COS(30.0) * X1), Y - (dobHeight / 3.0), X + dobWidth - X1, Y - (dobHeight / 3.0));
        Arc(X + dobWidth - X1, Y - (dobHeight / 3.0) - X1, X1, 0.0, 90.0);
        Line(X + dobWidth, Y - (dobHeight / 3.0) - X1, X + dobWidth, Y - dobHeight + X1);
        Arc(X + dobWidth - X1, Y - dobHeight + X1, X1, -90,0);
        Line(X + X1, Y - dobHeight, X + dobWidth - X1, Y - dobHeight);
        Arc (X + X1, Y - dobHeight + X1, X1, 180.0, 270.0);
        Writeln('(.5)');
        Writeln(NC_FORMAT('X%.3F', X) + NC_FORMAT('Y%.3F', Y));
        Writeln(NC_FORMAT('G91X%.3F', dobWidth));
        Writeln('G90Z' + C_Rpoint);
        Writeln(C_Zvalue);
        Writeln(NC_FORMAT('G91X-%.3F', dobWidth) + C_Fvalue);
        Writeln(NC_FORMAT('Y-%.3F', (dobHeight / 3.0) + (dobHeight / 8.0)));
        Writeln(NC_FORMAT('G02X%.3F', COS(30.0) * X1) + NC_FORMAT('Y%.3F', X1 / 2.0) + NC_FORMAT('R%.3F', X1));
        Writeln(NC_FORMAT('G01X%.3F', dobWidth - (COS(30.0) * X1) - X1));
        Writeln(NC_FORMAT('G02X%.3F', X1) + NC_FORMAT('Y-%.3F', X1) + NC_FORMAT('R%.3F', X1));
        Writeln(NC_FORMAT('G01Y-%.3F', dobHeight / 6.0));
        Writeln(NC_FORMAT('G02X-%.3F', X1) + NC_FORMAT('Y-%.3F', X1) + NC_FORMAT('R%.3F', X1));
        Writeln(NC_FORMAT('G01X-%.3F', dobHeight / 6.0));
        Writeln(NC_FORMAT('G02X-%.3F', X1) + NC_FORMAT('Y%.3F', X1) + NC_FORMAT('R%.3F', X1));
        Writeln('G90G00Z' + C_Initial);
      end;
      
      '6': //U}NCo
      begin
        X1 := dobHeight/4;
        Y1 := dobHeight/10;
        Arc(X + dobWidth - X1, Y - X1, X1, 0, 90);
        Line(X + dobWidth - X1, Y, X + X1, Y);
        Arc(X + X1, Y - X1, X1, 90.0, 180.0);
        Line(X, Y - X1, X, Y - dobHeight + X1);
        Arc(X + X1, Y - dobHeight + X1, X1, 180.0, 270.0);
        Line(X + X1, Y - dobHeight, X + dobWidth - X1, Y - dobHeight);
        Arc(X + dobWidth - X1, Y - dobHeight + X1, X1, -90,0);
        Line(X + dobWidth, Y - dobHeight + X1, X + dobWidth, Y - dobHeight + X1 + Y1);
        Arc(X + dobWidth - X1, Y - dobHeight + X1 + Y1, X1, 0.0, 90.0);
        Line(X + X1, Y - dobHeight + (X1 * 2.0) + Y1, X + dobWidth - X1, Y - dobHeight + (X1 * 2.0) + Y1);
        Arc(X + X1, Y - dobHeight + X1 + Y1, X1, 90.0, 180.0);
        Writeln('(.6)');
        Writeln(NC_FORMAT('X%.3F', X) + NC_FORMAT('Y%.3F', Y));
        Writeln(NC_FORMAT('G91X%.3F', dobWidth) + NC_FORMAT('Y-%.3F', X1));
        Writeln('G90Z' + C_Rpoint);
        Writeln(C_Zvalue);
        Writeln(NC_FORMAT('G91G03X-%.3F', X1) + NC_FORMAT('Y%.3F', X1) + NC_FORMAT('R%.3F', X1) + C_Fvalue);
        Writeln(NC_FORMAT('G01X-%.3F', dobWidth - (X1 * 2.0)));
        Writeln(NC_FORMAT('G03X-%.3F', X1) + NC_FORMAT('Y-%.3F', X1) + NC_FORMAT('R%.3F', X1));
        Writeln(NC_FORMAT('G01Y-%.3F', dobHeight - (X1 * 2.0)));
        Writeln(NC_FORMAT('G03X%.3F', X1) + NC_FORMAT('Y-%.3F', X1) + NC_FORMAT('R%.3F', X1));
        Writeln(NC_FORMAT('G01X%.3F', dobWidth - (X1 * 2.0)));
        Writeln(NC_FORMAT('G03X%.3F', X1) + NC_FORMAT('Y%.3F', X1) + NC_FORMAT('R%.3F', X1));
        Writeln(NC_FORMAT('G01Y%.3F', Y1));
        Writeln(NC_FORMAT('G03X-%.3F', X1) + NC_FORMAT('Y%.3F', X1) + NC_FORMAT('R%.3F', X1));
        Writeln(NC_FORMAT('G01X-%.3F', dobWidth - (X1 * 2.0)));
        Writeln(NC_FORMAT('G03X-%.3F', X1) + NC_FORMAT('Y-%.3F', X1) + NC_FORMAT('R%.3F', X1));
        Writeln('G90G00Z' + C_Initial);
      end;
      
      '7': //V}NCo
      begin
        X1 := dobWidth * 3.0 / 4.0;
        Line(X, Y, X + dobWidth, Y);
        Line(X + dobWidth, Y, X + dobWidth - X1, Y - dobHeight);
        Writeln('(.7)');
        Writeln(NC_FORMAT('X%.3F', X) + NC_FORMAT('Y%.3F', Y));
        Writeln('G90Z' + C_Rpoint);
        Writeln(C_Zvalue);
        Writeln(NC_FORMAT('G91X%.3F', dobWidth) + C_Fvalue);
        Writeln(NC_FORMAT('X-%.3F', X1) + NC_FORMAT('Y-%.3F', dobHeight));
        Writeln('G90G00Z' + C_Initial);
      end;
      
      '8': //W}NCo  
      begin
        X1 := dobHeight / 4.0;
        Y1 := dobWidth - (X1 * 2.0);
        Arc(X + X1, Y - X1, X1, 90.0, 270.0);
        Line(X + X1, Y, X + X1 + Y1, Y);
        Arc(X + dobWidth - X1, Y - X1, X1, -90.0, 90.0);
        Line(X + X1, Y - (X1 * 2.0), X + dobWidth - X1, Y - (X1 * 2.0));
        Arc(X + dobWidth - X1, Y - (X1 * 3.0), X1, -90.0, 90.0);
        Line(X + X1, Y - dobHeight, X + dobWidth - X1, Y - dobHeight);
        Arc(X + X1, Y - dobHeight + X1, X1, 90.0, 270.0);
        Writeln('(.8)');
        Writeln(NC_FORMAT('X%.3F', X) + NC_FORMAT('Y%.3F', Y));
        Writeln(NC_FORMAT('G91X%.3F', X1) + NC_FORMAT('Y-%.3F', X1 * 2.0));
        Writeln('G90Z' + C_Rpoint);
        Writeln(C_Zvalue);
        Writeln(NC_FORMAT('G91G02Y%.3F', X1 * 2.0) + NC_FORMAT('R%.3F', X1) + C_Fvalue);
        Writeln(NC_FORMAT('G01X%.3F', Y1));
        Writeln(NC_FORMAT('G02Y-%.3F', X1 * 2.0) + NC_FORMAT('R%.3F', X1));
        Writeln(NC_FORMAT('G01X-%.3F', Y1));
        Writeln(NC_FORMAT('G03Y-%.3F', X1 * 2.0) + NC_FORMAT('R%.3F', X1));
        Writeln(NC_FORMAT('G01X%.3F', Y1));
        Writeln(NC_FORMAT('G03Y%.3F', X1 * 2.0) + NC_FORMAT('R%.3F', X1));
        Writeln('G90G00Z' + C_Initial);
      end;
      
      '9': //X}NCo
      begin
        X1 := dobHeight / 4.0;
        Y1 := dobHeight / 10.0;
        Arc(X + dobWidth - X1, Y - X1 - Y1, X1, -90.0, 0.0);
        Line( X + dobWidth - X1, Y - (X1 * 2.0) - Y1, X + X1, Y - (X1 * 2.0) - Y1);
        Arc(X + X1, Y - X1 - Y1, X1, 180.0, 270.0);
        Line(X, Y - X1, X, Y - X1 - Y1);
        Arc(X + X1, Y - X1, X1, 90.0, 180.0);
        Line(X + X1, Y, X + dobWidth - X1, Y);
        Arc(X + dobWidth - X1, Y - X1, X1, 0.0, 90.0);
        Line(X + dobWidth, Y - X1, X + dobWidth, Y - dobHeight + X1);
        Arc(X + dobWidth - X1, Y - dobHeight + X1, X1, -90.0, 0.0);
        Line(X + X1, Y - dobHeight, X + dobWidth - X1, Y - dobHeight);
        Arc(X + X1, Y - dobHeight + X1, X1, 180.0, 270.0);
        Writeln('(.9)');
        Writeln(NC_FORMAT('X%.3F', X) + NC_FORMAT('Y%.3F', Y));
        Writeln(NC_FORMAT('G91X%.3F', dobWidth) + NC_FORMAT('Y-%.3F', X1 + Y1));
        Writeln('G90Z' + C_Rpoint);
        Writeln(C_Zvalue);
        Writeln(NC_FORMAT('G91G02X-%.3F', X1) + NC_FORMAT('Y-%.3F', X1) + NC_FORMAT('R%.3F', X1) + C_Fvalue);
        Writeln(NC_FORMAT('G01X-%.3F', dobWidth - (X1 * 2.0)));
        Writeln(NC_FORMAT('G02X-%.3F', X1) + NC_FORMAT('Y%.3F', X1) + NC_FORMAT('R%.3F', X1));
        Writeln(NC_FORMAT('G01Y%.3F', Y1));
        Writeln(NC_FORMAT('G02X%.3F', X1) + NC_FORMAT('Y%.3F', X1) + NC_FORMAT('R%.3F', X1));
        Writeln(NC_FORMAT('G01X%.3F', dobWidth - (X1 * 2.0)));
        Writeln(NC_FORMAT('G02X%.3F', X1) + NC_FORMAT('Y-%.3F', X1) + NC_FORMAT('R%.3F', X1));
        Writeln(NC_FORMAT('G01Y-%.3F', dobHeight - (X1 * 2.0)));
        Writeln(NC_FORMAT('G02X-%.3F', X1) + NC_FORMAT('Y-%.3F', X1) + NC_FORMAT('R%.3F', X1));
        Writeln(NC_FORMAT('G01X-%.3F', dobWidth - (X1 * 2.0)));
        Writeln(NC_FORMAT('G02X-%.3F', X1) + NC_FORMAT('Y%.3F', X1) + NC_FORMAT('R%.3F', X1));
        Writeln('G90G00Z' + C_Initial);
      end;
      
      '-': //|}NCo
      begin
        X1 := dobHeight / 2.0;
        Line(X, Y - X1, X + dobWidth, Y - X1);
        Writeln('(.-)');
        Writeln(NC_FORMAT('X%.3F', X) + NC_FORMAT('Y%.3F', Y));
        Writeln(NC_FORMAT('G91Y-%.3F', X1));
        Writeln('G90Z' + C_Rpoint);
        Writeln(C_Zvalue);
        Writeln(NC_FORMAT('G91X%.3F', dobWidth) + C_Fvalue);
        Writeln('G90G00Z' + C_Initial);
      end;
      
      '*': //~}NCo
      begin
        X1 := dobWidth / 2.0;
        Line(X, Y - (dobHeight / 2.0) + X1, X + dobWidth, Y - (dobHeight / 2.0) - X1);
        Line(X, Y - (dobHeight / 2.0) - X1, X + dobWidth, Y - (dobHeight / 2.0) + X1);
        Writeln('(.*)');
        Writeln(NC_FORMAT('X%.3F', X) + NC_FORMAT('Y%.3F', Y));
        Writeln(NC_FORMAT('G91Y-%.3F', (dobHeight / 2.0) - X1));
        Writeln('G90Z' + C_Rpoint);
        Writeln(C_Zvalue);
        Writeln(NC_FORMAT('G91X%.3F', dobWidth) + NC_FORMAT('Y-%.3F', dobWidth) + C_Fvalue);
        Writeln(NC_FORMAT('X-%.3F', X1) + NC_FORMAT('Y%.3F', X1));
        Writeln(NC_FORMAT('X-%.3F', X1) + NC_FORMAT('Y-%.3F', X1));
        Writeln(NC_FORMAT('X%.3F', dobWidth) + NC_FORMAT('Y%.3F', dobWidth));
        Writeln('G90G00Z' + C_Initial);
      end;
      
      '#': //}NCo
      begin
        X1 := dobWidth / 4.0;
        Y1 := dobHeight / 9.0;
        Line(X + X1, Y - Y1, X + X1, Y - dobHeight + Y1);
        Line(X + dobWidth - X1, Y - Y1, X + dobWidth - X1, Y - dobHeight + Y1);
        Line(X, Y - (dobHeight / 2.0) + X1, X + dobWidth, Y - (dobHeight / 2.0) + X1);
        Line(X, Y - (dobHeight / 2.0) - X1, X + dobWidth, Y - (dobHeight / 2.0) - X1);
        Writeln('(.#)');
        Writeln(NC_FORMAT('X%.3F', X) + NC_FORMAT('Y%.3F', Y));
        Writeln(NC_FORMAT('G91Y-%.3F', (dobHeight / 2.0) - X1));
        Writeln('G90Z' + C_Rpoint);
        Writeln(C_Zvalue);
        Writeln(NC_FORMAT('G91X%.3F', dobWidth) + C_Fvalue);
        Writeln(NC_FORMAT('X-%.3F', X1));
        Writeln(NC_FORMAT('Y%.3F', (dobHeight / 18.0 * 7.0) - X1));
        Writeln(NC_FORMAT('Y-%.3F',dobHeight / 9.0 * 7.0));
        Writeln(NC_FORMAT('Y%.3F', (dobHeight / 18.0 * 7.0) - X1));
        Writeln(NC_FORMAT('X%.3F', X1));
        Writeln(NC_FORMAT('X-%.3F', dobWidth));
        Writeln(NC_FORMAT('X%.3F', X1));
        Writeln(NC_FORMAT('Y-%.3F', (dobHeight / 18.0 * 7.0) - X1));
        Writeln(NC_FORMAT('Y%.3F', dobHeight / 9.0 * 7.0));
        Writeln('G90G00Z' + C_Initial);
      end;
      
      '/': //^}NCo
      begin
        Line(X + dobWidth, Y, X, Y - dobHeight);
        Writeln('(./)');
        Writeln(NC_FORMAT('X%.3F', X) + NC_FORMAT('Y%.3F', Y));
        Writeln(NC_FORMAT('G91X%.3F', dobWidth));
        Writeln('G90Z' + C_Rpoint);
        Writeln(C_Zvalue);
        Writeln(NC_FORMAT('G91X-%.3F', dobWidth) + NC_FORMAT('Y-%.3F', dobHeight) + C_Fvalue);
        Writeln('G90G00Z' + C_Initial);
      end;
    end;
  end;
  
  // vOI̍쐬
  Writeln(C_Ending1);
  
  OkMsgBox('XNvgI܂B' + #13#10 + #13#10 +
           'GfB^iCtrl + EjɂmbvO쐬Ă܂');
  
end.